// Ejemplo FreeImage 9
// Manipulacin de color
// Abril 2023, Salvador Pozo, Con Clase

#include <iostream>
#include <Freeimage.h>
#include <cmath>

int main(int argc, char**argv)
{
    FIBITMAP* dib;
    FIBITMAP* dib2;
	char *lpszPathName;
    FREE_IMAGE_FORMAT fif = FIF_UNKNOWN;
    BYTE lut[256];
    DWORD histo[256];

	if(argc < 2) {
        printf("Usar: FreeImage009 <fichero>\n");
        return 0;
	}
	lpszPathName = argv[1];

	fif = FreeImage_GetFileType(lpszPathName, 0);
	if(fif == FIF_UNKNOWN) {
		fif = FreeImage_GetFIFFromFilename(lpszPathName);
	}
	if((fif != FIF_UNKNOWN) && FreeImage_FIFSupportsReading(fif)) {
		dib = FreeImage_Load(fif, lpszPathName, 0);
		std::cout << "Fichero: " << lpszPathName << std::endl;

		if(FreeImage_HasPixels(dib)) {
		    FreeImage_GetHistogram(dib, histo, FICC_GREEN);
            std::cout << "histograma verde" << std::endl;
		    for(int i = 0; i < 256; i++) {
                std::cout << i << "," << histo[i] << std::endl;
		    }
            FreeImage_Unload(dib);

            // Volver a cargar imagen
            dib = FreeImage_Load(fif, lpszPathName, 0);
            FreeImage_AdjustBrightness(dib, -25);
            FreeImage_Save(FIF_JPEG, dib, "brillo-25.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib);

            // Volver a cargar imagen
            dib = FreeImage_Load(fif, lpszPathName, 0);
            FreeImage_AdjustContrast(dib, 25);
            FreeImage_Save(FIF_JPEG, dib, "contraste25.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib);

            // Volver a cargar imagen
            dib = FreeImage_Load(fif, lpszPathName, 0);
            FreeImage_Invert(dib);
            FreeImage_Save(FIF_JPEG, dib, "invertida.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib);

            // Volver a cargar imagen
            dib = FreeImage_Load(fif, lpszPathName, 0);
            FreeImage_AdjustGamma(dib, 1.2);
            FreeImage_Save(FIF_JPEG, dib, "ajustegamma.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib);

            // Volver a cargar imagen
            dib = FreeImage_Load(fif, lpszPathName, 0);
            for(int i=0; i<256; i++) if(i<128) lut[i] = 240-i; else lut[i] = i;
            FreeImage_AdjustCurve(dib, lut, FICC_RGB);
            FreeImage_Save(FIF_JPEG, dib, "curva1.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib);

            // Volver a cargar imagen
            dib = FreeImage_Load(fif, lpszPathName, 0);
            for(int i=0; i<256; i++) lut[i] = (BYTE) (34*std::log(i+1));
            FreeImage_AdjustCurve(dib, lut, FICC_RGB);
            FreeImage_Save(FIF_JPEG, dib, "curva2.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib);

            // Volver a cargar imagen
            dib = FreeImage_Load(fif, lpszPathName, 0);
            FreeImage_GetAdjustColorsLookupTable(lut, -5, 5, 0.9, FALSE);
            FreeImage_Save(FIF_JPEG, dib, "ajustetablacolor.jpg", JPEG_DEFAULT);
            FreeImage_Unload(dib);
		}
    }

    return 0;
}
